100 rem Mandala24 with save
102 rem Original by Steve Pool with input from
104 rem TMD for the spriograph.
106 rem Repackaged by pjw for high colour,
108 rem variable screen sizes and save image.
110 rem V0.2, 2021 Jul 28
112 :
114 :
116 sdr$    = 'ram2_':                              rem Save directory
118 nsv     = 5:                                    rem Max save no. before overwrite (1..)
120 aspect  = 1:                                    rem Aspect ratio
122 fade_on = 1:                                    rem Fade after display 0 = off
124 randomise: colour_24
126 open#0; con: open#1; con
128 xs% = 3 * scr_xlim / 5: ys% = scr_ylim - 20:    rem Fade/Save block size
130 xo% = scr_xlim / 5: yo% = 10:                   rem Fade block position
132 WINDOW scr_xlim,scr_ylim,0,0
134 SCALE 400,-155,0
136 :
138 if 0 then
140  rem Test
142  block xs%, ys%, xo%, yo%, -1
144  ink 0: ELLIPSE 200,200, 180, aspect, 0
146  pause: quit
148 endif
150 :
152 main
154 :
156 DEFine PROCedure main
158 LOCal rpt,n$,loop,rd,q$,loop2,xt,hh,vv,zz
160 rem WINDOW 348,256,0,0: SCALE 400,0,0: aspect=.76
162 WINDOW#0; scr_xlim,scr_ylim,0,0
164 SCALE 400,-155,0: rem aspect=1 .76
166 rem BORDER 1,255:
168 PAPER 0: OVER 0: CLS
170 rem WINDOW #2,scr_xlim,20,0,scr_ylim - 20: PAPER#2,0
172 rem BORDER #2,1,255: INK #2,7: CLS #2
174 rem WINDOW #0,164,54,348,202
176 rem PAPER #0,0: INK #0,7: CLS #0
178 REPeat rpt: mandala
180 END DEFine main
182 :
184 DEFine PROCedure mandala
186 LOCal a,b,f,i,h1,v1,v,h,i$
188 n$='002003004005006008009010012015018020024030036040045060072090120180'
190 REPeat loop
192  INK RndCol
194  IF RND(2)=0 THEN
196   rd=RND(1 TO 22)* 3: INK RndCol
198   q$=n$(rd-2)&n$(rd-1)&n$(rd): innr=q$
200  ELSE : innr=RND(2 TO 180): END IF
202  outr=180: penr=RND(1 TO innr): xt=0
204  rem PRINT#2,outr!innr!penr\
206  a=0: b=0: f=0: i=.1: h1=0: v1=0
208 hh=0: vv=0: zz=0
210 FOR loop2=1 TO 768
212   b=-(a*outr)/innr
214   v=INT(((outr-innr)*SIN(a)-penr*SIN(b))+.5)
216   h=INT(((outr-innr)*COS(a)-penr*COS(b))+.5): h=h*aspect
218   IF f=2: IF loop2>256: IF zz>0: IF hh=(h-h1): IF vv=(v-v1): xt=1
220   IF f=2: POINT 200+h1,200+v1: LINE_R TO h-h1,v-v1 : IF zz=0: hh=h-h1: vv=v-v1: zz=1
222 IF xt=1: EXIT loop2
224   IF f<2: f=f+1
226   h1=h: v1=v: a=a+i
228  END FOR loop2: rem PAUSE 99
230 :
232  IF RND(7)=0 then
234   for cntdn = 5 to 0 step -1
236    k% = code(INKEY$(30))
238    sel on k%
240     = 10: SaveMandala#1: exit cntdn
242     = 32: cls#0; 3: next loop:                      rem Dont wipe just yet!
244     = 27: quit: rem IF i$=="s": STOP
246    endsel
248    at#0; 0,0: print#0; '<ENTER>'! fill$(".", cntdn),,
250   endfor cntdn
252   if fade_on: Fade: else: cls: endif: rem pause 150: burst: rem CLS#2
254  else: sel on code(inkey$(99)): = 27: quit: = 10: SaveMandala#1
256  endif
258 END REPeat loop
260 END DEFine mandala
262 ::
264 DEFine PROCedure burst
266 LOCal radius
268 ink 0: rem FOR radius=180 TO 1 STEP -1
270 for radius = 1 to 200
272 rem INK radius
274 rem ELLIPSE 200,200,radius,aspect,0: PAUSE 1: INK 0
276 ELLIPSE 200,200,radius,aspect,0
278 END FOR radius: pause 50: CLS
280 END DEFine
282 ::
284 def fn RndCol
286 loc c
288 ret rnd(255) * 65536 + rnd(255) * 256 + rnd(255):               rem Full spectrum
290 rem c = rnd(255): ret c * 65536 + c * 256 + c:                      rem Greyscale
292 rem c = rnd(145 to 255): ret c * 65536 + rnd(c) * 256 + rnd(c):     rem Red cast?
294 enddef RndCol
296 ::
298 def proc Fade
300 loc i%
302 alpha_blend 10
304 for i% = 1 to machine
306  at#0; 0,0: print#0; i%,
308  block xs%, ys%, xo%, yo%, 0: if code(inkey$(5)) = 27: quit
310 endfor i%
312 alpha_blend 255: cls: pause 10
314 enddef Fade
316 ::
318 def proc SaveMandala(ch)
320 loc adr, cp, md%, ll%, bpp
322 rem GLOBal fnm$, xs%, ys%, xo%, yo%
324 :
326 md% = disp_type
328 sel on md%
330  = 0, 8:   bpp = 0.25: ll% = ((xs% + 7) div 8) * 2
332  = 16:     bpp = 1:    ll% = ((xs% + 1) div 2) * 2
334  = 32, 33: bpp = 2:    ll% = xs% * 2
336  = remainder : ert -19
338 endsel
340 :
342 fnm$ = NextName$
344 cp = fop_over(fnm$)
346 wput#cp; $4afc, xs%, ys%, ll%, md% * 256:  rem Output PIC header
348 for adr = scr_base(#ch) + yo% * scr_llen(#ch) + xo% * bpp to scr_base(#ch) + (yo% + ys%) * scr_llen(#ch) + (xo% + xs%) * bpp step scr_llen(#ch)
350  bput#cp; peek$(adr, ll%)
352 endfor adr
354 close#cp: beep 2000, 20
356 enddef SaveMandala
358 :
360 :
362 DEFine FuNction NextName$
364 LOCal i%, n%, cf, t, dt(nsv)
366 rem GLOBal sdr$, nsv
368 :
370 FOR i% = 0 TO nsv
372  cf = FOPEN(sdr$ & 'mandala' & i% & '_pic')
374  SELect ON cf
376   = -7: RETurn sdr$ & 'mandala' & i% & '_pic'
378  = 0 TO 99: dt(i%) = FUPDT(#cf): CLOSE#cf
380  END SELect
382 END FOR i%
384 :
386 n% = 0: t = dt(n%)
388 FOR i% = 1 TO nsv:  IF dt(i%) < t: t = dt(i%): n% = i%
390 RETurn sdr$ & 'mandala' & n% & '_pic'
392 END DEFine NextName$
394 :
396 :
